#include <iostream>

#include "testlib.h"

using namespace std;

void writeTest(int first_test, int last_test, int test_num){
    vector <int> tests = {0, 10, 1, 3, 4, 6, 7, 8, 9, 11, 13, 14, 15, 16, 18, 19, 20};
    startTest(test_num);

    int n;

    if (test_num < tests.size()) {
        n = tests[test_num];
    }
    else if (test_num < tests.size() + 6)
    {
        vector<int> mod4 = {2, 3, 0, 2, 3, 1};
        vector<int> div4 = {7, 12, 16, 19, 21, 24};
        n = div4[test_num - tests.size()] * 4 + mod4[test_num - tests.size()];
    }
    else if (test_num == 28)
        n = 2e9;
    else
    {
        int max = 2e9 / 4 - 1;
        int min = max / 2;
        n = rnd.next(min, max) * 4 + test_num % 4;
    }
    cout << n << endl;
}

int main(int argc, char* argv[])
{
    int firstTest = atoi(argv[1]);
    int lastTest = atoi(argv[2]);

    for(int testNum = firstTest; testNum <= lastTest; testNum++){
        writeTest(firstTest, lastTest, testNum);
    }

    return 0;
}
