#include <iostream>

#include "testlib.h"

using namespace std;

void gen_test(int min_val, int max_val, int idx, vector<int> & ans)
{
    while (true)
    {
        for (int i = 0; i < 4; ++i)
            ans[i] = rnd.next(min_val, max_val);
        int m1 = ans[0] + ans[2] + 2;
        int m2 = ans[1] + ans[3] + 2;
        int m3 = max(ans[0], ans[1]) + 2;
        int m4 = max(ans[2], ans[3]) + 2;
        int m = min(min(m1, m2), min(m3, m4));
        if (idx == 0 || idx == 1)
        {
            if (m1 == m && m2 > m && m3 > m && m4 > m)
            {
                return;
            }
        }
        else if (idx == 2 || idx == 3)
        {
            if (m1 > m && m2 == m && m3 > m && m4 > m)
            {
                return;
            }
        }
        else if (idx == 4 || idx == 5)
        {
            if (m1 > m && m2 > m && m3 == m && m4 > m)
            {
                if (ans[0] < ans[1])
                    swap(ans[0], ans[1]);
                if (idx == 5)
                    swap(ans[0], ans[1]);
                return;
            }
        }
        else
        {
            if (m1 > m && m2 > m && m3 >= m && m4 == m)
            {
                if (ans[2] < ans[3])
                    swap(ans[2], ans[3]);
                if (idx == 7)
                    swap(ans[2], ans[3]);
                return;
            }
        }
    }
}


void writeTest(int first_test, int last_test, int test_num){
    vector <int> ans(4);
    startTest(test_num);
    switch (test_num)
    {
        case 1: ans = {6, 2, 7, 3}; break;
        // Равные числа
        case 2: ans = {1, 1, 1, 1}; break;
        case 3: ans = {10, 10, 10, 10}; break;
        // Тесты с нулями (8 штук)
        case 4: ans = {0, 2, 5, 1}; break;
        case 5: ans = {9, 0, 5, 2}; break;
        case 6: ans = {10, 7, 0, 4}; break;
        case 7: ans = {5, 6, 7, 0}; break;
        case 8: ans = {4, 0, 2, 0}; break;
        case 9: ans = {1, 0, 1, 0}; break;
        case 10: ans = {0, 7, 0, 8}; break;
        case 11: ans = {0, 1, 0, 1}; break;
        // Тесты общие - группы по 8 штук
        default:
        int idx =  (test_num - 12) % 8;
        int group = (test_num - 12) / 8;
        int MIN_VAL[] = {2, 100, 40000, (int)0.4e9, (int)0.4e9};
        int MAX_VAL[] = {10, 1000, 100000, (int)1e9, (int)1e9};
        int min_val = MIN_VAL[group], max_val = MAX_VAL[group];
        gen_test(min_val, max_val, idx, ans);
    }

    for (auto x: ans)
        cout << x << endl;

    
}

int main(int argc, char* argv[])
{
    int firstTest = atoi(argv[1]);
    int lastTest = atoi(argv[2]);

    for(int testNum = firstTest; testNum <= lastTest; testNum++){
        writeTest(firstTest, lastTest, testNum);
    }

    return 0;
}

