#include "testlib.h"

int MAX[] = {10, 10, 1000, (int)1e5, (int)1e9 };

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    ensuref(0 <= group && group < sizeof(MAX) / sizeof(int), "Incorrect test group");

    int a = inf.readInt(0, MAX[group], "A");
    inf.readEoln();
    int b = inf.readInt(0, MAX[group], "B");
    inf.readEoln();
    int c = inf.readInt(0, MAX[group], "C");
    inf.readEoln();
    int d = inf.readInt(0, MAX[group], "D");
    inf.readEoln();
    
    ensuref(a > 0  && c > 0 || b > 0 && d > 0, "No possible solution");
    
    inf.readEof();
}
