#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int GROUP_N = 5;
const vector<int> MAX_ANS_LEN = {5, 5, 9, 18, 100};

int ans_len(long long n);

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);

    int group = atoi(validator.group().data());
    ensuref(0 <= group && group < GROUP_N, "Incorrect test group %d", group);

    long long n = inf.readLong(1, 1'000'000'000'000'000'000, "n");
    inf.readEoln();

    ensuref(ans_len(n) <= MAX_ANS_LEN[group], "Too large answer in group %d", group);

    inf.readEof();
}

int ans_len(long long n)
{
    if (n < 2)
        return 1;
    int len = 0, d = 9;
    while (d > 1)
    {
        while (n % d == 0)
        {
            len++;
            n /= d;
        }
        d--;
    }
    if (n > 1)
        return 1;
    else
        return len;
}
