#pragma GCC optimize("O0")

#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

int main() {
    ll n;
    cin >> n;
    if (n < 2)
    {
        cout << n << endl;
        return 0;
    }
    vector<int> digits;
    int d = 9;
    while (d > 1)
    {
        while (n % d == 0)
        {
            digits.push_back(d);
            n /= d;
        }
        d--;
    }
    if (n > 1)
        cout << -1;
    else
    {
        reverse(digits.begin(), digits.end());
        for (auto d: digits)
            cout << d;
    }
    cout << endl;
}
